#include<iostream>
using namespace std;

float dpdt(float t, float p) {
	return (3 * p - pow(p, 1.5));
}

void RungeKutta(float t0, float p0, float t, float h) {
	int n = (int)((t - t0) / h);
	float k1, k2, k3, k4, k5;
	float p = p0;

	cout << "t\tp\n" << endl;
	for (int i = 1; i <= n; i++) {

		k1 = h * dpdt(t0, p);
		k2 = h * dpdt(t0 + 0.5 * h, p + 0.5 * k1);
		k3 = h * dpdt(t0 + 0.5 * h, p + 0.5 * k2);
		k4 = h * dpdt(t0 + h, p + k3);

		p = p + (1.0 / 6.0) * (k1 + 2 * k2 + 2 * k3 + k4);
		t0 = t0 + h;
	
		cout << t0 << "\t" << p << endl;
	}
}

int main() {
	float t0 = 0, t = 5, p0 = 1, h = 0.25;	
	RungeKutta(t0, p0, t, h);
}
